Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2715)
@@ -21,48 +21,39 @@
    PUBLIC   p4z_sink         ! called in p4zbio.F90
    PUBLIC   p4z_sink_init    ! called in trcsms_pisces.F90
-
-   !! * Shared module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-     wsbio3, wsbio4,      &    !: POC and GOC sinking speeds
-     wscal                     !: Calcite and BSi sinking speeds
-
-   !! * Module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-     sinking, sinking2,   &    !: POC sinking fluxes (different meanings depending on the parameterization
-     sinkcal, sinksil,    &    !: CaCO3 and BSi sinking fluxes
-     sinkfer                   !: Small BFe sinking flux
-
-   INTEGER  :: &
-      iksed  = 10              !
+   PUBLIC   p4z_sink_alloc
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wsbio3   !: POC sinking speed 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wsbio4   !: GOC sinking speed
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   wscal    !: Calcite and BSi sinking speeds
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinking, sinking2  !: POC sinking fluxes 
+   !                                                          !  (different meanings depending on the parameterization)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkcal, sinksil   !: CaCO3 and BSi sinking fluxes
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfer            !: Small BFe sinking fluxes
+#if ! defined key_kriest
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfer2           !: Big iron sinking fluxes
+#endif
+
+   INTEGER  :: iksed  = 10
 
 #if  defined key_kriest
-   REAL(wp)          ::       &   
-      xkr_sfact    = 250.  ,  &   !: Sinking factor
-      xkr_stick    = 0.2   ,  &   !: Stickiness
-      xkr_nnano    = 2.337 ,  &   !: Nbr of cell in nano size class
-      xkr_ndiat    = 3.718 ,  &   !: Nbr of cell in diatoms size class
-      xkr_nmeso    = 7.147 ,  &   !: Nbr of cell in mesozoo  size class
-      xkr_naggr    = 9.877        !: Nbr of cell in aggregates  size class
-
-   REAL(wp)          ::       &   
-      xkr_frac
-
-   REAL(wp), PUBLIC ::        &
-      xkr_dnano            ,  &   !: Size of particles in nano pool
-      xkr_ddiat            ,  &   !: Size of particles in diatoms pool
-      xkr_dmeso            ,  &   !: Size of particles in mesozoo pool
-      xkr_daggr            ,  &   !: Size of particles in aggregates pool
-      xkr_wsbio_min        ,  &   !: min vertical particle speed
-      xkr_wsbio_max               !: max vertical particle speed
-
-   REAL(wp), PUBLIC, DIMENSION(jpk) ::   &   !:
-      xnumm                       !:     maximum number of particles in aggregates
-
-#endif
-
-#if ! defined key_kriest
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &   !:
-     sinkfer2                  !: Big Fe sinking flux
-#endif 
+   REAL(wp) ::  xkr_sfact    = 250.     !: Sinking factor
+   REAL(wp) ::  xkr_stick    = 0.2      !: Stickiness
+   REAL(wp) ::  xkr_nnano    = 2.337    !: Nbr of cell in nano size class
+   REAL(wp) ::  xkr_ndiat    = 3.718    !: Nbr of cell in diatoms size class
+   REAL(wp) ::  xkr_nmeso    = 7.147    !: Nbr of cell in mesozoo  size class
+   REAL(wp) ::  xkr_naggr    = 9.877    !: Nbr of cell in aggregates  size class
+
+   REAL(wp) ::  xkr_frac 
+
+   REAL(wp), PUBLIC ::  xkr_dnano       !: Size of particles in nano pool
+   REAL(wp), PUBLIC ::  xkr_ddiat       !: Size of particles in diatoms pool
+   REAL(wp), PUBLIC ::  xkr_dmeso       !: Size of particles in mesozoo pool
+   REAL(wp), PUBLIC ::  xkr_daggr       !: Size of particles in aggregates pool
+   REAL(wp), PUBLIC ::  xkr_wsbio_min   !: min vertical particle speed
+   REAL(wp), PUBLIC ::  xkr_wsbio_max   !: max vertical particle speed
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   xnumm   !:  maximum number of particles in aggregates
+#endif
 
    !!* Substitution
@@ -71,10 +62,12 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
 #if defined key_kriest
+   !!----------------------------------------------------------------------
+   !!   'key_kriest'                                                    ???
+   !!----------------------------------------------------------------------
 
    SUBROUTINE p4z_sink ( kt, jnt )
@@ -87,6 +80,9 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   znum3d => wrk_3d_2
+      !
       INTEGER, INTENT(in) :: kt, jnt
+      !
       INTEGER  :: ji, jj, jk
       REAL(wp) :: zagg1, zagg2, zagg3, zagg4, zagg5, zaggsi, zaggsh
@@ -99,19 +95,21 @@
       INTEGER  :: ik1
 #endif
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   znum3d
       CHARACTER (len=25) :: charout
-
-      !!---------------------------------------------------------------------
-
+      !!---------------------------------------------------------------------
+      !
+      IF( wrk_in_use(3, 2 ) ) THEN
+         CALL ctl_stop('p4z_sink: requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
+      
       !     Initialisation of variables used to compute Sinking Speed
       !     ---------------------------------------------------------
 
-       znum3d(:,:,:) = 0.e0
-       zval1 = 1. + xkr_zeta
-       zval2 = 1. + xkr_zeta + xkr_eta
-       zval3 = 1. + xkr_eta
-
-     !     Computation of the vertical sinking speed : Kriest et Evans, 2000
-     !     -----------------------------------------------------------------
+      znum3d(:,:,:) = 0.e0
+      zval1 = 1. + xkr_zeta
+      zval2 = 1. + xkr_zeta + xkr_eta
+      zval3 = 1. + xkr_eta
+
+      !     Computation of the vertical sinking speed : Kriest et Evans, 2000
+      !     -----------------------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -131,7 +129,7 @@
                   zdiv1 = zeps - zval3
                   wsbio3(ji,jj,jk) = xkr_wsbio_min * ( zeps - zval1 ) / zdiv    &
-     &                             - xkr_wsbio_max *   zgm * xkr_eta  / zdiv
+                     &             - xkr_wsbio_max *   zgm * xkr_eta  / zdiv
                   wsbio4(ji,jj,jk) = xkr_wsbio_min *   ( zeps-1. )    / zdiv1   &
-     &                             - xkr_wsbio_max *   zfm * xkr_eta  / zdiv1
+                     &             - xkr_wsbio_max *   zfm * xkr_eta  / zdiv1
                   IF( znum == 1.1)   wsbio3(ji,jj,jk) = wsbio4(ji,jj,jk)
                ENDIF
@@ -140,5 +138,5 @@
       END DO
 
-      wscal(:,:,:) = MAX( wsbio3(:,:,:), 50. )
+      wscal(:,:,:) = MAX( wsbio3(:,:,:), 50._wp )
 
       !   INITIALIZE TO ZERO ALL THE SINKING ARRAYS
@@ -305,11 +303,14 @@
 #endif
       !
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('sink')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
-
+      ENDIF
+      !
+      IF( wrk_not_released(3, 2 ) )   CALL ctl_stop('p4z_sink: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_sink
+
 
    SUBROUTINE p4z_sink_init
@@ -324,5 +325,4 @@
       !!
       !! ** input   :   Namelist nampiskrs
-      !!
       !!----------------------------------------------------------------------
       INTEGER  ::   jk, jn, kiter
@@ -330,9 +330,9 @@
       REAL(wp) ::   zws, zwr, zwl,wmax, znummax
       REAL(wp) ::   zmin, zmax, zl, zr, xacc
-
+      !
       NAMELIST/nampiskrs/ xkr_sfact, xkr_stick ,  &
          &                xkr_nnano, xkr_ndiat, xkr_nmeso, xkr_naggr
-
       !!----------------------------------------------------------------------
+      !
       REWIND( numnat )                     ! read nampiskrs
       READ  ( numnat, nampiskrs )
@@ -347,25 +347,25 @@
          WRITE(numout,*) '    Nbr of cell in mesozoo size class        xkr_nmeso    = ', xkr_nmeso
          WRITE(numout,*) '    Nbr of cell in aggregates size class     xkr_naggr    = ', xkr_naggr
-     ENDIF
-
-
-     ! max and min vertical particle speed
-     xkr_wsbio_min = xkr_sfact * xkr_mass_min**xkr_eta
-     xkr_wsbio_max = xkr_sfact * xkr_mass_max**xkr_eta
-     WRITE(numout,*) ' max and min vertical particle speed ', xkr_wsbio_min, xkr_wsbio_max
-
-     !
-     !    effect of the sizes of the different living pools on particle numbers
-     !    nano = 2um-20um -> mean size=6.32 um -> ws=2.596 -> xnum=xnnano=2.337
-     !    diat and microzoo = 10um-200um -> 44.7 -> 8.732 -> xnum=xndiat=3.718
-     !    mesozoo = 200um-2mm -> 632.45 -> 45.14 -> xnum=xnmeso=7.147
-     !    aggregates = 200um-10mm -> 1414 -> 74.34 -> xnum=xnaggr=9.877
-     !    doc aggregates = 1um
-     ! ----------------------------------------------------------
-
-     xkr_dnano = 1. / ( xkr_massp * xkr_nnano )
-     xkr_ddiat = 1. / ( xkr_massp * xkr_ndiat )
-     xkr_dmeso = 1. / ( xkr_massp * xkr_nmeso )
-     xkr_daggr = 1. / ( xkr_massp * xkr_naggr )
+      ENDIF
+
+
+      ! max and min vertical particle speed
+      xkr_wsbio_min = xkr_sfact * xkr_mass_min**xkr_eta
+      xkr_wsbio_max = xkr_sfact * xkr_mass_max**xkr_eta
+      WRITE(numout,*) ' max and min vertical particle speed ', xkr_wsbio_min, xkr_wsbio_max
+
+      !
+      !    effect of the sizes of the different living pools on particle numbers
+      !    nano = 2um-20um -> mean size=6.32 um -> ws=2.596 -> xnum=xnnano=2.337
+      !    diat and microzoo = 10um-200um -> 44.7 -> 8.732 -> xnum=xndiat=3.718
+      !    mesozoo = 200um-2mm -> 632.45 -> 45.14 -> xnum=xnmeso=7.147
+      !    aggregates = 200um-10mm -> 1414 -> 74.34 -> xnum=xnaggr=9.877
+      !    doc aggregates = 1um
+      ! ----------------------------------------------------------
+
+      xkr_dnano = 1. / ( xkr_massp * xkr_nnano )
+      xkr_ddiat = 1. / ( xkr_massp * xkr_ndiat )
+      xkr_dmeso = 1. / ( xkr_massp * xkr_nmeso )
+      xkr_daggr = 1. / ( xkr_massp * xkr_naggr )
 
       !!---------------------------------------------------------------------
@@ -379,7 +379,7 @@
       WRITE(numout,*)'    kriest : Compute maximum number of particles in aggregates'
 
-      xacc     =  0.001
+      xacc     =  0.001_wp
       kiter    = 50
-      zmin     =  1.10
+      zmin     =  1.10_wp
       zmax     = xkr_mass_max / xkr_mass_min
       xkr_frac = zmax
@@ -402,47 +402,43 @@
             &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
             & - wmax
-iflag:  DO jn = 1, kiter
-           IF( zwl == 0.e0 ) THEN
-              znummax = zl
-           ELSE IF ( zwr == 0.e0 ) THEN
-              znummax = zr
-           ELSE
-              znummax = ( zr + zl ) / 2.
-              zdiv = xkr_zeta + xkr_eta - xkr_eta * znummax
-              znum = znummax - 1.
-              zws =  xkr_wsbio_min * xkr_zeta / zdiv &
-                 & - ( xkr_wsbio_max * xkr_eta * znum * &
-                 &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
-                 & - wmax
-              IF( zws * zwl < 0. ) THEN
-                 zr = znummax
-              ELSE
-                 zl = znummax
-              ENDIF
-              zdiv = xkr_zeta + xkr_eta - xkr_eta * zl
-              znum = zl - 1.
-              zwl =  xkr_wsbio_min * xkr_zeta / zdiv &
-                 & - ( xkr_wsbio_max * xkr_eta * znum * &
-                 &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
-                 & - wmax
-
-              zdiv = xkr_zeta + xkr_eta - xkr_eta * zr
-              znum = zr - 1.
-              zwr =  xkr_wsbio_min * xkr_zeta / zdiv &
-                 & - ( xkr_wsbio_max * xkr_eta * znum * &
-                 &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
-                 & - wmax
-
-              IF ( ABS ( zws )  <= xacc ) EXIT iflag
-
-           ENDIF
-
-        END DO iflag
-
-        xnumm(jk) = znummax
-        WRITE(numout,*) '       jk = ', jk, ' wmax = ', wmax,' xnum max = ', xnumm(jk)
-
-     END DO
-
+iflag:   DO jn = 1, kiter
+            IF    ( zwl == 0._wp ) THEN   ;   znummax = zl
+            ELSEIF( zwr == 0._wp ) THEN   ;   znummax = zr
+            ELSE
+               znummax = ( zr + zl ) / 2.
+               zdiv = xkr_zeta + xkr_eta - xkr_eta * znummax
+               znum = znummax - 1.
+               zws =  xkr_wsbio_min * xkr_zeta / zdiv &
+                  & - ( xkr_wsbio_max * xkr_eta * znum * &
+                  &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
+                  & - wmax
+               IF( zws * zwl < 0. ) THEN   ;   zr = znummax
+               ELSE                        ;   zl = znummax
+               ENDIF
+               zdiv = xkr_zeta + xkr_eta - xkr_eta * zl
+               znum = zl - 1.
+               zwl =  xkr_wsbio_min * xkr_zeta / zdiv &
+                  & - ( xkr_wsbio_max * xkr_eta * znum * &
+                  &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
+                  & - wmax
+
+               zdiv = xkr_zeta + xkr_eta - xkr_eta * zr
+               znum = zr - 1.
+               zwr =  xkr_wsbio_min * xkr_zeta / zdiv &
+                  & - ( xkr_wsbio_max * xkr_eta * znum * &
+                  &     xkr_frac**( -xkr_zeta / znum ) / zdiv ) &
+                  & - wmax
+               !
+               IF ( ABS ( zws )  <= xacc ) EXIT iflag
+               !
+            ENDIF
+            !
+         END DO iflag
+
+         xnumm(jk) = znummax
+         WRITE(numout,*) '       jk = ', jk, ' wmax = ', wmax,' xnum max = ', xnumm(jk)
+         !
+      END DO
+      !
   END SUBROUTINE p4z_sink_init
 
@@ -476,5 +472,5 @@
          DO jj = 1, jpj
             DO ji=1,jpi
-               zfact = MAX( 0., fsdepw(ji,jj,jk+1) - hmld(ji,jj) ) / 4000.
+               zfact = MAX( 0., fsdepw(ji,jj,jk+1) - hmld(ji,jj) ) / 4000._wp
                wsbio4(ji,jj,jk) = wsbio2 + ( 200.- wsbio2 ) * zfact
             END DO
@@ -584,11 +580,12 @@
 #endif
       !
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('sink')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
-
+      ENDIF
+      !
    END SUBROUTINE p4z_sink
+
 
    SUBROUTINE p4z_sink_init
@@ -611,4 +608,7 @@
       !!      transport term, i.e.  div(u*tra).
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: ztraz => wrk_3d_2, zakz => wrk_3d_3, zwsink2 => wrk_3d_4
+      !
       INTEGER , INTENT(in   )                         ::   jp_tra    ! tracer index index      
       REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pwsink    ! sinking speed
@@ -617,8 +617,10 @@
       INTEGER  ::   ji, jj, jk, jn
       REAL(wp) ::   zigma,zew,zign, zflx, zstep
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztraz, zakz
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zwsink2
-      !!---------------------------------------------------------------------
-
+      !!---------------------------------------------------------------------
+
+      IF(  wrk_in_use(3, 2,3,4 ) ) THEN
+         CALL ctl_stop('p4z_sink2: requested workspace arrays unavailable')
+         RETURN
+      END IF
 
       zstep = rfact2 / 2.
@@ -701,10 +703,30 @@
       END DO
 
-      trn(:,:,:,jp_tra) = trb(:,:,:,jp_tra)
-      psinkflx(:,:,:)   = 2. * psinkflx(:,:,:)
-
+      trn     (:,:,:,jp_tra) = trb(:,:,:,jp_tra)
+      psinkflx(:,:,:)        = 2. * psinkflx(:,:,:)
+      !
+      IF( wrk_not_released(3, 2,3,4) )   CALL ctl_stop('p4z_sink2: failed to release workspace arrays')
       !
    END SUBROUTINE p4z_sink2
 
+
+   INTEGER FUNCTION p4z_sink_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_sink_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( wsbio3 (jpi,jpj,jpk) , wsbio4  (jpi,jpj,jpk) , wscal(jpi,jpj,jpk) ,     &
+         &      sinking(jpi,jpj,jpk) , sinking2(jpi,jpj,jpk)                      ,     &                
+         &      sinkcal(jpi,jpj,jpk) , sinksil (jpi,jpj,jpk)                      ,     &                
+#if defined key_kriest
+         &      xnumm(jpk)                                                        ,     &                
+#else
+         &      sinkfer2(jpi,jpj,jpk)                                             ,     &                
+#endif
+         &      sinkfer(jpi,jpj,jpk)                                              , STAT=p4z_sink_alloc )                
+         !
+      IF( p4z_sink_alloc /= 0 ) CALL ctl_warn('p4z_sink_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION p4z_sink_alloc
+   
 #else
    !!======================================================================
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2715)
@@ -7,5 +7,4 @@
    !!             3.2  !  2009-04 (C. Ethe & NEMO team) style
    !!----------------------------------------------------------------------
-
 #if defined key_pisces
    !!----------------------------------------------------------------------
@@ -38,42 +37,44 @@
    !!* Damping 
    LOGICAL  ::   ln_pisdmp         !: relaxation or not of nutrients to a mean value
-                                   !: when initialize from a restart file 
    LOGICAL  ::   ln_pisclo         !: Restoring or not of nutrients to initial value
                                    !: on close seas
 
    !!*  Biological fluxes for light
-   INTEGER , DIMENSION(jpi,jpj)     ::   neln       !: number of T-levels + 1 in the euphotic layer
-   REAL(wp), DIMENSION(jpi,jpj)     ::   heup       !: euphotic layer depth
+   INTEGER , ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::  neln       !: number of T-levels + 1 in the euphotic layer
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::  heup       !: euphotic layer depth
 
    !!*  Biological fluxes for primary production
-   REAL(wp), DIMENSION(jpi,jpj)     ::   xksi       !: ???
-   REAL(wp), DIMENSION(jpi,jpj)     ::   xksimax    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xnanono3   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiatno3   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xnanonh4   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiatnh4   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimphy    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimdia    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   concdfe    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   concnfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::   xksi       !: ???
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::   xksimax    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanono3   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatno3   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanonh4   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatnh4   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimphy    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimdia    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   concdfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   concnfe    !: ???
 
    !!*  SMS for the organic matter
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xfracal    !: ??
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   nitrfac    !: ??
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimbac    !: ??
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiss      !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xfracal    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   nitrfac    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xlimbac    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xdiss      !: ??
 #if defined key_diatrc
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prodcal    !: Calcite production
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazing    !: Total zooplankton grazing
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prodcal    !: Calcite production
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   grazing    !: Total zooplankton grazing
 #endif
 
    !!* Variable for chemistry of the CO2 cycle
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   akb3       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ak13       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ak23       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   aksp       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   akw3       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   borat      !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   hi         !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   akb3       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ak13       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ak23       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   aksp       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   akw3       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   borat      !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hi         !: ???
+
+   !!* Array used to indicate negative tracer values
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xnegtr     !: ???
 
 #if defined key_kriest
@@ -85,4 +86,51 @@
 #endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   INTEGER FUNCTION sms_pisces_alloc()
+      !!----------------------------------------------------------------------
+      !!        *** ROUTINE sms_pisces_alloc ***
+      !!----------------------------------------------------------------------
+      USE lib_mpp , ONLY: ctl_warn
+      INTEGER ::   ierr(5)        ! Local variables
+      !!----------------------------------------------------------------------
+      ierr(:) = 0
+      !
+      !*  Biological fluxes for light
+      ALLOCATE( neln(jpi,jpj), heup(jpi,jpj),                           STAT=ierr(1) )
+      !
+      !*  Biological fluxes for primary production
+      ALLOCATE( xksimax(jpi,jpj)     , xksi(jpi,jpj)        ,               &
+         &      xnanono3(jpi,jpj,jpk), xdiatno3(jpi,jpj,jpk),               &
+         &      xnanonh4(jpi,jpj,jpk), xdiatnh4(jpi,jpj,jpk),               &
+         &      xlimphy (jpi,jpj,jpk), xlimdia (jpi,jpj,jpk),               &
+         &      concdfe (jpi,jpj,jpk), concnfe (jpi,jpj,jpk),           STAT=ierr(2) ) 
+         !
+      !*  SMS for the organic matter
+      ALLOCATE( xfracal (jpi,jpj,jpk), nitrfac (jpi,jpj,jpk),               &
+#if defined key_diatrc
+         &      prodcal(jpi,jpj,jpk) , grazing(jpi,jpj,jpk) ,               &
+#endif 
+         &      xlimbac (jpi,jpj,jpk), xdiss(jpi,jpj,jpk)   ,           STAT=ierr(3) )  
+         !
+      !* Variable for chemistry of the CO2 cycle
+      ALLOCATE( akb3(jpi,jpj,jpk), ak13(jpi,jpj,jpk) ,                      &
+         &      ak23(jpi,jpj,jpk), aksp(jpi,jpj,jpk) ,                      &
+         &      akw3(jpi,jpj,jpk), borat(jpi,jpj,jpk), hi(jpi,jpj,jpk), STAT=ierr(4) )
+         !
+      !* Array used to indicate negative tracer values  
+      ALLOCATE( xnegtr(jpi,jpj,jpk),                                    STAT=ierr(5) )
+      !
+      sms_pisces_alloc = MAXVAL( ierr )
+      !
+      IF( sms_pisces_alloc /= 0 )   CALL ctl_warn('sms_pisces_alloc: failed to allocate arrays') 
+      !
+   END FUNCTION sms_pisces_alloc
+
 #else
    !!----------------------------------------------------------------------   
@@ -91,8 +139,4 @@
 #endif
    
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================   
 END MODULE sms_pisces    
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2715)
@@ -21,5 +21,11 @@
    USE oce_trc         ! ocean variables
    USE p4zche 
-   USE lib_mpp
+   USE p4zche          ! 
+   USE p4zsink         ! 
+   USE p4zopt          ! 
+   USE p4zprod         !
+   USE p4zrem          ! 
+   USE p4zsed          ! 
+   USE p4zflx          ! 
 
    IMPLICIT NONE
@@ -28,13 +34,11 @@
    PUBLIC   trc_ini_pisces   ! called by trcini.F90 module
 
-   !! * Module variables
-   REAL(wp) :: &
-      sco2   =  2.312e-3         , &
-      alka0  =  2.423e-3         , &
-      oxyg0  =  177.6e-6         , &
-      po4    =  2.174e-6         , &
-      bioma0 =  1.000e-8         , &
-      silic1 =  91.65e-6         , &
-      no3    =  31.04e-6 * 7.6
+   REAL(wp) :: sco2   =  2.312e-3_wp
+   REAL(wp) :: alka0  =  2.423e-3_wp
+   REAL(wp) :: oxyg0  =  177.6e-6_wp 
+   REAL(wp) :: po4    =  2.174e-6_wp 
+   REAL(wp) :: bioma0 =  1.000e-8_wp  
+   REAL(wp) :: silic1 =  91.65e-6_wp  
+   REAL(wp) :: no3    =  31.04e-6_wp * 7.6_wp
 
 #  include "top_substitute.h90"
@@ -42,7 +46,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -53,13 +56,10 @@
       !! ** Purpose :   Initialisation of the PISCES biochemical model
       !!----------------------------------------------------------------------
-
-
-      !  Control consitency
-      CALL trc_ctl_pisces
-
-
+      !
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) ' trc_ini_pisces :   PISCES biochemical model initialisation'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+      CALL pisces_alloc()                          ! Allocate PISCES arrays
 
       !                                            ! Time-step
@@ -126,28 +126,40 @@
       IF(lwp) WRITE(numout,*) 'Initialization of PISCES tracers done'
       IF(lwp) WRITE(numout,*) ' '
-
       !
    END SUBROUTINE trc_ini_pisces
- 
-   SUBROUTINE trc_ctl_pisces
+
+
+   SUBROUTINE pisces_alloc
       !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ctl_pisces  ***
+      !!                     ***  ROUTINE pisces_alloc  ***
       !!
-      !! ** Purpose :   control the cpp options, namelist and files 
+      !! ** Purpose :   Allocate all the dynamic arrays of PISCES 
       !!----------------------------------------------------------------------
+      USE p4zint , ONLY : p4z_int_alloc      
+      USE p4zsink, ONLY : p4z_sink_alloc      
+      USE p4zopt , ONLY : p4z_opt_alloc           
+      USE p4zprod, ONLY : p4z_prod_alloc         
+      USE p4zrem , ONLY : p4z_rem_alloc           
+      USE p4zsed , ONLY : p4z_sed_alloc          
+      USE p4zflx , ONLY : p4z_flx_alloc
+      !
+      INTEGER :: ierr
+      !!----------------------------------------------------------------------
+      !
+      ierr =         sms_pisces_alloc()          ! Start of PISCES-related alloc routines...
+      ierr = ierr +     p4z_che_alloc()
+      ierr = ierr +     p4z_int_alloc()
+      ierr = ierr +    p4z_sink_alloc()
+      ierr = ierr +     p4z_opt_alloc()
+      ierr = ierr +    p4z_prod_alloc()
+      ierr = ierr +     p4z_rem_alloc()
+      ierr = ierr +     p4z_sed_alloc()
+      ierr = ierr +     p4z_flx_alloc()
+      !
+      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'pisces_alloc: unable to allocate PISCES arrays' )
+      !
+   END SUBROUTINE pisces_alloc
 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' use PISCES biological model '
-
-   ! Check number of tracers
-   ! -----------------------
-#if  defined key_kriest
-      IF( jp_pisces /= 23) CALL ctl_stop( ' PISCES must have 23 passive tracers. Change jp_pisces in par_pisces.F90' )
-#else
-      IF( jp_pisces /= 24) CALL ctl_stop( ' PISCES must have 24 passive tracers. Change jp_pisces in par_pisces.F90' )
-#endif
-
-   END SUBROUTINE trc_ctl_pisces
-  
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2715)
@@ -19,5 +19,4 @@
    USE trc             ! TOP variables
    USE sms_pisces      ! sms trends
-   USE in_out_manager  ! I/O manager
 
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2715)
@@ -18,9 +18,6 @@
    USE trcsms_pisces          ! pisces sms trends
    USE sms_pisces          ! pisces sms variables
-   USE in_out_manager  ! I/O manager
    USE iom
    USE trcdta
-   USE lib_mpp
-   USE lib_fortran
 
    IMPLICIT NONE
@@ -108,12 +105,10 @@
       !! ** purpose  : Relaxation of some tracers
       !!----------------------------------------------------------------------
-      INTEGER  :: ji, jj, jk
-      REAL(wp) ::  &
-         alkmean = 2426. ,  & ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
-         po4mean = 2.165 ,  & ! mean value of phosphates
-         no3mean = 30.90 ,  & ! mean value of nitrate
-         silmean = 91.51      ! mean value of silicate
-
-      REAL(wp) :: zarea, zvol, zalksum, zpo4sum, zno3sum, zsilsum
+      REAL(wp) ::  alkmean = 2426.     ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
+      REAL(wp) ::  po4mean = 2.165     ! mean value of phosphates
+      REAL(wp) ::  no3mean = 30.90     ! mean value of nitrate
+      REAL(wp) ::  silmean = 91.51     ! mean value of silicate
+
+      REAL(wp) :: zarea, zalksum, zpo4sum, zno3sum, zsilsum
 
 
